package org.jeecg.modules.ctop.controller;

import cn.com.ctop.common.module.constant.CtopRoleCodeConstant;
import cn.com.ctop.common.module.entity.Advertiser;
import cn.com.ctop.common.module.entity.MaterialInfo;
import cn.com.ctop.common.module.entity.Project;
import cn.com.ctop.common.module.entity.UserCompany;
import cn.com.ctop.common.module.mapper.ProjectMapper;
import cn.com.ctop.common.module.mapper.UserCompanyMapper;
import cn.com.ctop.common.module.service.*;
import cn.com.ctop.common.module.utils.Check;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.entity.SysUser;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.ctop.entity.ProjectMember;
import org.jeecg.modules.ctop.entity.TransferAccount;
import org.jeecg.modules.ctop.mapper.ProjectMemberMapper;
import org.jeecg.modules.ctop.service.IAdvertiserService;
import org.jeecg.modules.ctop.service.IProjectMemberService;
import org.jeecg.modules.ctop.service.ITransferAccountService;
import org.jeecg.modules.system.service.ISysRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * 项目
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-19
 */
@Slf4j
@Api(tags = "项目")
@RestController
@RequestMapping("/ctop/project")
public class ProjectController {
    @Autowired
    private IProjectService projectService;
    @Autowired
    private IProjectMemberService projectMemberService;
    @Autowired
    private ProjectMemberMapper projectMemberMapper;
    @Autowired
    private IAdvertiserService advertiserService;
    @Autowired
    private ProjectMapper projectMapper;
    @Autowired
    private ITransferAccountService transferAccountService;
    @Autowired
    private IUserAllocationService userAllocationService;
    @Autowired
    private ISysRoleExtService sysRoleService;
    @Autowired
    private ISysRoleService roleService;
    @Autowired
    private IMaterialInfoService materialInfoService;
    @Resource
    private UserCompanyMapper userCompanyMapper;


    @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
    @GetMapping(value = "/getProjectList")
    public Result<IPage<Project>> getProjectList(Project project,
                                                 @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                 @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                 HttpServletRequest req) {
        Result<IPage<Project>> result = new Result<>();
        String projectName = project.getProjectName();
        project.setProjectName(null);
        QueryWrapper<Project> queryWrapper = QueryGenerator.initQueryWrapper(project, req.getParameterMap());
        if (!Check.isNull(projectName)) {
            queryWrapper.like("project_name", projectName);
        }
        Page<Project> page = new Page<>(pageNo, pageSize);
        IPage<Project> pageList = projectService.page(page, queryWrapper);
        List<Project> records = pageList.getRecords();
        records = transferAccountService.getTransferInfoListByList(records);
        pageList.setRecords(records);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }


    /**
     * @param advertiserId
     * @param mediaId
     * @return
     */
    @GetMapping(value = "/getProjectByAdvertiserAndMediaId")
    public Result<List<Project>> getProjectByCompany(String advertiserId, String mediaId) {
        Result<List<Project>> result = new Result<>();
        try {
            QueryWrapper<Project> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("media_id", mediaId);
            queryWrapper.eq("advertiser_id", advertiserId);
            List<Project> projects = projectMapper.selectList(queryWrapper);
            result.setSuccess(true);
            result.setResult(projects);
        } catch (Exception e) {
            e.printStackTrace();
            result.setSuccess(false);
        }
        return result;
    }


    @GetMapping("/getProjectListByMediaId")
    public Result<Object> getProjectListByMediaId(String mediaId) {
        try {
            QueryWrapper<Project> queryWrapper = new QueryWrapper<>();
            List<String> mediaIds = new ArrayList<>();
            if ("16".equals(mediaId)) {
                mediaIds.add("16");
            } else if ("1".equals(mediaId)) {
                mediaIds.add("1");
                mediaIds.add("3");
            } else {
                mediaIds.add("2");
                mediaIds.add("4");
            }
            queryWrapper.in("media_id", mediaIds);
            List<Project> projects = projectMapper.selectList(queryWrapper);
            return Result.ok(projects);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return Result.error("fail");
    }


    /**
     * 我管理的
     *
     * @param userId
     * @return
     */
    @ApiOperation(value = "项目成员-分页列表查询", notes = "项目成员-分页列表查询")
    @GetMapping(value = "/responsibleList")
    public Map<String, Object> responsibleList(String userId) {
        Map<String, Object> map = new HashMap<>();
        String roleCode = sysRoleService.getRoleCodeByUserId(userId);
        QueryWrapper<Project> queryWrapper = new QueryWrapper<>();
        List<Project> projects = new ArrayList<>();
        if (!CtopRoleCodeConstant.COMMON_ROLE_CODE_ADMIN.equals(roleCode) && !"sale".equals(roleCode) && !"saleDirector".equals(roleCode)) {
            if ("designTeamLeader".equals(roleCode) || "touTiaoOperationManager".equals(roleCode) || "kuaishouOperationManager".equals(roleCode) || "planeLeader".equals(roleCode)) {
                QueryWrapper<ProjectMember> memberQueryWrapper = new QueryWrapper<>();
                memberQueryWrapper.eq("user_id", userId);
                memberQueryWrapper.groupBy("project_id");
                memberQueryWrapper.orderByDesc("create_time");
                List<ProjectMember> projectMemberList = projectMemberMapper.selectList(memberQueryWrapper);
                if (!Check.isNull(projectMemberList)) {
                    for (ProjectMember member : projectMemberList) {
                        Long projectId = member.getProjectId();
                        Project project = projectService.getById(projectId);
                        if (null != project) {
                            projects.add(project);
                        }
                    }
                }
            } else {
                QueryWrapper<Project> projectQueryWrapper = new QueryWrapper<>();
                projectQueryWrapper.eq("responsible_id", userId);
                projectQueryWrapper.orderByDesc("create_time");
                List<Project> responsibles = projectMapper.selectList(projectQueryWrapper);
                if (!Check.isNull(responsibles)) {
                    projects = responsibles;
                } else {
                    QueryWrapper<Project> designResponsibleQueryWrapper = new QueryWrapper<>();
                    designResponsibleQueryWrapper.eq("design_responsible_id", userId);
                    designResponsibleQueryWrapper.orderByDesc("create_time");
                    List<Project> designResponsibles = projectMapper.selectList(projectQueryWrapper);
                    projects = designResponsibles;
                }
            }
        } else {
            queryWrapper.orderByDesc("create_time");
            projects = projectMapper.selectList(queryWrapper);
        }

        if (!Check.isNull(projects)) {
            for (Project project : projects) {
                QueryWrapper<TransferAccount> transferAccountQueryWrapper = new QueryWrapper<>();
                transferAccountQueryWrapper.eq("project_id", project.getId());
                transferAccountQueryWrapper.eq("status", 0);
                List<TransferAccount> list = transferAccountService.list(transferAccountQueryWrapper);
                project.setNeedExamine(list.size());
            }
        }

        map.put("success", true);
        map.put("code", 0);
        map.put("result", projects);
        return map;
    }


    @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
    @GetMapping(value = "/responsibleListV2")
    public Result<IPage<Project>> responsibleListV2(Project project,
                                                    @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                    @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                    HttpServletRequest req) {
        Result<IPage<Project>> result = new Result<>();
        String userId = project.getUserId();
        if (Check.isNull(userId)) {
            result.setSuccess(false);
            result.setMessage("用户信息不能为空");
            return result;
        }
        project.setUserId(null);
        String projectName = project.getProjectName();
        project.setProjectName(null);
        String roleCode = sysRoleService.getRoleCodeByUserId(userId);

        QueryWrapper<Project> queryWrapper = QueryGenerator.initQueryWrapper(project, req.getParameterMap());
        if (!Check.isNull(projectName)) {
            queryWrapper.like("project_name", projectName);
        }
        queryWrapper.orderByDesc("create_time");
        Page<Project> page = new Page<>(pageNo, pageSize);
        IPage<Project> pageList = null;
        // 查询所有
        if (CtopRoleCodeConstant.COMMON_ROLE_CODE_ADMIN.equals(roleCode)) {
            pageList = projectService.page(page, queryWrapper);
            // 经理岗查询所在项目
        } else if ("designTeamLeader".equals(roleCode) || "touTiaoOperationManager".equals(roleCode) || "kuaishouOperationManager".equals(roleCode) || "planeLeader".equals(roleCode)) {
            List<Long> projectIds = projectMemberService.getProjectByMap(userId);
            if (!Check.isNull(projectIds)) {
                queryWrapper.in("id", projectIds);
                pageList = projectService.page(page, queryWrapper);
            }
            // 剪辑 编导 平面 拍摄 查询自己为设计负责人项目
        } else if ("clip".equals(roleCode) || "shot".equals(roleCode) || "plan".equals(roleCode) || "plane".equals(roleCode)) {
            queryWrapper.eq("design_responsible_id", userId);
            pageList = projectService.page(page, queryWrapper);
            // 运营 运营助理查询 自己负责项目
        } else if ("operator".equals(roleCode) || "operationAssistant".equals(roleCode)) {
            queryWrapper.eq("responsible_id", userId);
            pageList = projectService.page(page, queryWrapper);
        } else if (roleCode.contains("sale")) {
            queryWrapper.eq("sale_id", userId);
            pageList = projectService.page(page, queryWrapper);
        } else {
            queryWrapper.eq("responsible_id", userId);
            pageList = projectService.page(page, queryWrapper);
        }
        List<Project> records = pageList.getRecords();
        records = transferAccountService.getTransferInfoListByList(records);
        pageList.setRecords(records);
        result.setResult(pageList);
        return result;
    }


    /**
     * 分页列表查询
     *
     * @param project
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "项目-分页列表查询", notes = "项目-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<Project>> queryPageList(Project project,
                                                @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                HttpServletRequest req) {
        Result<IPage<Project>> result = new Result<>();
        String projectName = project.getProjectName();
        project.setProjectName(null);
        String userId = project.getUserId();
        project.setUserId(null);

        QueryWrapper<Project> queryWrapper = QueryGenerator.initQueryWrapper(project, req.getParameterMap());
        Page<Project> page = new Page<>(pageNo, pageSize);


        String roleCode = sysRoleService.getRoleCodeByUserId(userId);
        List<String> userIds = new ArrayList<>();
        if ("bytedanceDirector".equals(roleCode)) {
            userIds = roleService.getCompanyUsers(roleCode, userId);
        } else if ("kuaishouDirector".equals(roleCode)) {
            userIds = roleService.getCompanyUsers(roleCode, userId);
        } else if ("operator".equals(roleCode) || "kuaishouOperationManager".equals(roleCode) || "touTiaoOperationManager".equals(roleCode)) {
            queryWrapper.eq("responsible_id", userId);

        } else if ("plane".equals(roleCode) || "plan".equals(roleCode) || "shot".equals(roleCode) || "clip".equals(roleCode) || "designTeamLeader".equals(roleCode) || "planeLeader".equals(roleCode)) {
            queryWrapper.eq("design_responsible_id", userId);
        } else if (roleCode.contains("sale") || "CompanyManager".equals(roleCode)) {
            QueryWrapper<UserCompany> userCompanyQueryWrapper = new QueryWrapper<>();
            userCompanyQueryWrapper.eq("user_id", userId);
            userCompanyQueryWrapper.orderByDesc("create_time");
            userCompanyQueryWrapper.last("limit 1");
            UserCompany userCompany = userCompanyMapper.selectOne(userCompanyQueryWrapper);
            if (!Check.isNull(userCompany)) {
                queryWrapper.eq("company_id", userCompany.getCompanyId());
            }
        }
        if (!Check.isNull(userIds)) {
            queryWrapper.in("user_id", userIds);
        }
        if (!Check.isNull(projectName)) {
            queryWrapper.like("project_name", projectName);
        }
        //媒体类型 1、3 头条   2、4 快手
        if (!Check.isNull(project.getMediaId())) {
            queryWrapper.in("media_id", Arrays.asList(project.getMediaId().split(",")));
        }
        queryWrapper.orderByDesc("create_time");
        IPage<Project> pageList = projectService.page(page, queryWrapper);
        List<Project> records = pageList.getRecords();
        records = transferAccountService.getTransferInfoListByList(records);
        pageList.setRecords(records);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param project
     * @return
     */
    @Autowired
    private ISysUserService sysUserService;

    @ApiOperation(value = "项目-添加", notes = "项目-添加")
    @PostMapping(value = "/add")
    public Result<Project> add(@RequestBody JSONObject data) {
        Project project = JSONObject.parseObject(data.toJSONString(), Project.class);
        Result<Project> result = new Result<>();
        try {
         /*   String advertiserId = project.getAdvertiserId();
            Advertiser advertiser = advertiserService.getById(advertiserId);*/
            Map<String, String> memberMap = new HashMap<>();
            QueryWrapper<UserCompany> userCompanyQueryWrapper = new QueryWrapper<>();
            userCompanyQueryWrapper.eq("user_id", project.getUserId());
            userCompanyQueryWrapper.orderByDesc("create_time");
            userCompanyQueryWrapper.last("limit 1");
            UserCompany userCompany = userCompanyMapper.selectOne(userCompanyQueryWrapper);
            if (!Check.isNull(userCompany)) {
                project.setCompanyId(userCompany.getCompanyId());
            }
            // 运营负责人
            SysUser sysUser = sysUserService.getById(project.getResponsibleId());
            if (!Check.isNull(sysUser)) {
                memberMap.put(sysUser.getId(), sysUser.getRealname());
            }
            // 设计负责人
            SysUser designSysUser = sysUserService.getById(project.getDesignResponsibleId());
            if (!Check.isNull(designSysUser)) {
                memberMap.put(designSysUser.getId(), designSysUser.getRealname());
            }
            // 销售
            SysUser saleSysUser = sysUserService.getById(project.getSaleId());
            if (!Check.isNull(saleSysUser)) {
                memberMap.put(saleSysUser.getId(), saleSysUser.getRealname());
            }
            projectService.save(project);

            Long id = project.getId();
            for (Map.Entry<String, String> projectMember : memberMap.entrySet()) {
                String userId = projectMember.getKey();
                String userName = projectMember.getValue();
                Map<String, Object> map = new HashMap<>();
                map.put("project_id", id);
                map.put("user_id", userId);
                projectMemberService.removeByMap(map);
                ProjectMember member = new ProjectMember();
                member.setProjectId(id);
                member.setProjectName(project.getProjectName());
                member.setUserId(userId);
                member.setUserName(userName);
                String roleCode = sysRoleService.getRoleCodeByUserId(userId);
                if (!Check.isNull(roleCode)) {
                    member.setRoleCode(roleCode);
                }
                projectMemberService.save(member);
            }
            result.success("添加成功！");
        } catch (Exception e) {
            e.printStackTrace();
            result.error500("操作失败");
        }
        return result;
    }


    /**
     * 编辑
     *
     * @param project
     * @return
     */
    @ApiOperation(value = "项目-编辑", notes = "项目-编辑")
    @PutMapping(value = "/edit")
    public Result<Project> edit(@RequestBody JSONObject data) {
        Project project = JSONObject.parseObject(data.toJSONString(), Project.class);
        Result<Project> result = new Result<>();
        SysUser sysUser = sysUserService.getById(project.getResponsibleId());
        if (!Check.isNull(sysUser)) {
            projectMemberService.addMember(sysUser, project);
        }

        SysUser designSysUser = sysUserService.getById(project.getDesignResponsibleId());
        if (!Check.isNull(designSysUser)) {
            projectMemberService.addMember(designSysUser, project);
        }

        SysUser saleSysUser = sysUserService.getById(project.getSaleId());
        if (!Check.isNull(saleSysUser)) {
            projectMemberService.addMember(saleSysUser, project);
        }

        Project projectEntity = projectService.getById(project.getId());
        if (projectEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = projectService.updateById(project);
            QueryWrapper<ProjectMember> memberQueryWrapper = new QueryWrapper<>();
            memberQueryWrapper.eq("project_id", project.getId());
            ProjectMember updateMember = new ProjectMember();
            updateMember.setProjectName(project.getProjectName());
            projectMemberService.update(updateMember, memberQueryWrapper);
            if (!projectEntity.getSupplierCode().equals(project.getSupplierCode())) {
                QueryWrapper<MaterialInfo> materialInfoQueryWrapper = new QueryWrapper<>();
                materialInfoQueryWrapper.eq("project_id", project.getId());
                MaterialInfo updateMaterialInfo = new MaterialInfo();
                updateMaterialInfo.setSupplierCode(project.getSupplierCode());
                materialInfoService.update(updateMaterialInfo, materialInfoQueryWrapper);
            }

            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }


    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "项目-通过id删除", notes = "项目-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<Object> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            projectService.removeById(id);
            Map<String, Object> deleteMap = new HashMap<>();
            deleteMap.put("project_id", id);
            projectMemberService.removeByMap(deleteMap);
            userAllocationService.removeByMap(deleteMap);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @ApiOperation(value = "项目-批量删除", notes = "项目-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<Project> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<Project> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.projectService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "项目-通过id查询", notes = "项目-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<Project> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<Project> result = new Result<>();
        Project project = projectService.getById(id);
        if (project == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(project);
            result.setSuccess(true);
        }
        return result;
    }
}
